
jQuery(window).resize(function(){
    ctlArcadeGalleryResize();
});

jQuery(window).ready(function(){

    jQuery(".ctl-arcade-admin-game-gallery").each(function(){
        var aGallery = [];
        var i = 0;
        jQuery(this).children(".ctl-arcade-admin-game-gallery-item").each(function(){
            jQuery(this).attr("data-index", i);
            i++;
            aGallery.push({ srcFullSize : jQuery(this).attr("data-fullsize") })
        });
        jQuery(this).data("ctl-gallery-data", aGallery);


        jQuery(this).children(".ctl-arcade-admin-game-gallery-item").each(function(){
            jQuery(this).on("click", function(){
                var aGalleryData = jQuery(this).closest(".ctl-arcade-admin-game-gallery").data("ctl-gallery-data");
                var id     = ctlArcadeMakeCode();
                var szHtml = '<div id="'+ id +'" class="ctl-arcade-gallery-wrapper">';
                    szHtml += '<div class="ctl-arcade-gallery-block"></div>';
                    szHtml += '<div class="ctl-arcade-gallery-content">';
                        szHtml += '<img src="'+ jQuery(this).attr("data-fullsize") +'"/>';
                        szHtml += '<div title="left" class="ctl-arcade-gallery-left ctl-arcade-icon-left-open"></div>';
                        szHtml += '<div title="right" class="ctl-arcade-gallery-right ctl-arcade-icon-right-open"></div>';
                        szHtml += '<div title="close" class="ctl-arcade-gallery-close ctl-arcade-icon-cancel"></div>';
                    szHtml += '</div>';
                szHtml += '</div>';
                jQuery("body").append(szHtml);
                jQuery("#"+id).data("ctl-gallery-data", aGalleryData);
                jQuery("#"+id).data("ctl-gallery-cur-item", jQuery(this).attr("data-index"));
                jQuery("#"+id+" img").on("load",function(){
                    ctlArcadeGalleryResize();
                });
            });
        });
    });

    jQuery(document).on("click", ".ctl-arcade-gallery-block", function(){
        jQuery(this).closest(".ctl-arcade-gallery-wrapper").remove();
    });

    jQuery(document).on("click", ".ctl-arcade-gallery-close", function(){
        jQuery(this).closest(".ctl-arcade-gallery-wrapper").remove();
    });

    jQuery(document).on("click", ".ctl-arcade-gallery-left", function(){
        var oWrapper = jQuery(this).closest(".ctl-arcade-gallery-wrapper");
        var index = oWrapper.data("ctl-gallery-cur-item");
        var aGallery = oWrapper.data("ctl-gallery-data");

        index--;
        if( index < 0 ){
            index = aGallery.length-1;
        }

        oWrapper.data("ctl-gallery-cur-item", index);
        oWrapper.find("img").attr("src", aGallery[index].srcFullSize);
    });

    jQuery(document).on("click", ".ctl-arcade-gallery-right", function(){
        var oWrapper = jQuery(this).closest(".ctl-arcade-gallery-wrapper");
        var index = oWrapper.data("ctl-gallery-cur-item");
        var aGallery = oWrapper.data("ctl-gallery-data");

        index++;
        if( index == aGallery.length ){
            index = 0;
        }

        oWrapper.data("ctl-gallery-cur-item", index);
        oWrapper.find("img").attr("src", aGallery[index].srcFullSize);
    });
});

function ctlArcadeGalleryResize(){
    jQuery(".ctl-arcade-gallery-wrapper img").each(function(){
        var rw = jQuery(this)[0].naturalWidth;
        var rh = jQuery(this)[0].naturalHeight;
        var w = window.innerWidth - 60;
        var h = window.innerHeight - 60;
        multiplier = Math.min((h / rh), (w / rw));
        var destW = rw * multiplier;
        var destH = rh * multiplier;

        if( destW > rw && destH > rh ){
            destW = rw;
            destH = rh;
        }

        jQuery(this).css("width",destW+"px");
        jQuery(this).css("height",destH+"px");

        jQuery(this).closest(".ctl-arcade-gallery-content").css("width",destW+"px");
        jQuery(this).closest(".ctl-arcade-gallery-content").css("height",destH+"px");
    });
}

function ctlArcadeMakeCode() {
    var code = "";
    var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    for( var i=0; i < 32; i++ )
        code += chars.charAt(Math.floor(Math.random() * chars.length));
    return code;
}
