<?php

    function ctl_arcade_page_settings() {
        global $wpdb;

        ?>
        <div class="ctl-arcade-wrapper">
            <?php
           /*     echo  _ctl_arcade_strip_response_header(
                    _ctl_arcade_send_to_host(
                        "showcase.codethislab.com","GET","/feeds/ctl-arcade/ctl_arcade_news.php"));
*/
            ?>
        <h2>CTL Arcade Settings</h2>
        <?php

        $szAction = trim(filter_input(INPUT_GET, 'action'));

        switch($szAction){

            case "ad_preloader":{
                $data =
                    base64_decode(
                        strtr( filter_input(INPUT_GET, 'code'), '-_,', '+/=')
                    );
                $data = addslashes($data);

                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    $data . "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE . "'");

                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    filter_input(INPUT_GET, 'mintime') .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_MIN_TIME . "'");

                ?>
                <p class="ctl-arcade-admin-message-green">AD Preloader changed.</p>
            <?php
            }break;

            case "ad_interlevel":{

                $data =
                    base64_decode(
                        strtr( filter_input(INPUT_GET, 'code'), '-_,', '+/=')
                    );
                $data = addslashes($data);

                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    $data .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE . "'");
                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    filter_input(INPUT_GET, 'mintime') .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_MIN_TIME . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">AD Interlevel changed.</p>
            <?php
            }break;


            case "extra_css":{
                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    base64_decode(  strtr( filter_input(INPUT_GET, 'css'), '-_,', '+/=')) .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_EXTRA_CSS . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">Extra CSS settings changed.</p>
            <?php
            }break;
            case "fb_app_settings":{
                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    trim(filter_input(INPUT_GET, 'fb_app_id')) .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_FB_APP_ID . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">FB App settings changed.</p>
                <?php
            }break;
			case "twitter_settings":{
				 $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    trim(filter_input(INPUT_GET, 'twitter_share')) .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_TWITTER_SHARE . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">Twitter share settings changed.</p>
			  <?php
			}break;
            case "min_time_between_ads":{
                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    trim(filter_input(INPUT_GET, 'time')) .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_MIN_TIME_BETWEEN_ADS . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">Min time between ads changed.</p>
            <?php
            }break;
            case "empty_scores": {
                $wpdb->query("TRUNCATE " . CTL_ARCADE_DB_TABLE_SCORES);
                ?>
                <p class="ctl-arcade-admin-message-green">No Scores in DB.</p>
            <?php
            }break;
            case "empty_ratings":{
                $wpdb->query( "TRUNCATE ". CTL_ARCADE_DB_TABLE_RATINGS );

                $szQuery = "UPDATE  " . CTL_ARCADE_DB_TABLE_GAMES;
                $szQuery .= " SET game_rating_value_votes = 0, game_rating_num_votes = 0";
                $wpdb->query( $szQuery );
                ?>
                <p class="ctl-arcade-admin-message-green">No Ratings in DB.</p>
            <?php
            }break;
            case "rank_style":{
                $wpdb->query( "UPDATE " . CTL_ARCADE_DB_TABLE_SETTINGS . " SET option_value = '" .
                    trim(filter_input(INPUT_GET, 'color')) .
                    "' WHERE option_name = '" . CTL_ARCADE_SETTINGS_KEY_RANK_STYLE . "'");
                ?>
                <p class="ctl-arcade-admin-message-green">Leaderboard color changed.</p>
            <?php
            }break;
        }

            _ctl_arcade_page_all_settings();
            ctl_arcade_print_footer();
        ?>
        </div>
        <?php
    }


    function _ctl_arcade_page_all_settings() {
        $szRankColor = ctl_arcade_get_rank_style_color();
        $fbAppId     = ctl_arcade_get_fb_app_id();
		$iTwitterShare = intval(ctl_arcade_get_twitter_share());
        $extraCss    = ctl_arcade_get_extra_css();
        $iMinTimeBetweenAds = ctl_arcade_get_min_time_between_ads();
        $oAdInterLevel = ctl_arcade_get_ad_interlevel();
        $oAdPreLoader  = ctl_arcade_get_ad_preloader();

        ?>

        <h3>Scores</h3>
        <p>Empty all scores from DB:</p>
        <a onclick="ctl_arcade_clear_scores()" class="ctl-arcade-btn ctl-arcade-btn-mini">empty scores</a>

        <h3>Ratings</h3>
        <p>Empty all ratings from DB:</p>
        <a onclick="ctl_arcade_clear_ratings()" class="ctl-arcade-btn ctl-arcade-btn-mini">empty ratings</a>

        <h3>Facebook app id</h3>
        <p>Share your game page on Facebook:</p>
        <input type="text" id="ctl-arcade-id-fb-app-id-value" value="<?php echo $fbAppId; ?>">
        <a onclick="ctl_arcade_save_fb_app_id()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>

		<h3>Twitter share</h3>
        <p>Share your game page on Twitter:</p>
        <input type="checkbox" id="ctl-arcade-id-tw-share-value" <?php echo $iTwitterShare === 1 ? 'checked' : ''; ?> >
        <a onclick="ctl_arcade_save_twitter_share()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>

        <h3>Min time between ads</h3>
        <p>Minimum time between ads in seconds:</p>
        <input type="number" min="1" max="120" id="ctl-arcade-id-min-time-between-ads" value=<?php echo $iMinTimeBetweenAds; ?> onkeypress="return isNumberKey(event)">
        <a onclick="ctl_arcade_save_min_time_between_ads()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>

        <h3>Preloader AD</h3>
        <p>Minimum duration of preloader ad in seconds:</p>
        <input type="number" min="1" max="120" id="ctl-arcade-id-ad-preloader-min-time" value=<?php echo $oAdPreLoader[CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_MIN_TIME]; ?> onkeypress="return isNumberKey(event)">
        <p>Insert your ad code, it will appear before the game:</p>
        <textarea rows="3" cols="50" id="ctl-arcade-id-ad-preloader-code"><?php echo $oAdPreLoader[CTL_ARCADE_SETTINGS_KEY_AD_PRELOADER_CODE]; ?></textarea>
        <a onclick="ctl_arcade_save_ad_preloader()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>

        <h3>Interlevel AD</h3>
        <p>Minimum duration of interlevel ad in seconds:</p>
        <input type="number" min="1" max="120" id="ctl-arcade-id-ad-interlevel-min-time" value=<?php echo $oAdInterLevel[CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_MIN_TIME]; ?> onkeypress="return isNumberKey(event)">
        <p>Insert your ad code, it will appear at the end of each game level and when users quit the game:</p>
        <textarea rows="3" cols="50" id="ctl-arcade-id-ad-interlevel-code"><?php echo $oAdInterLevel[CTL_ARCADE_SETTINGS_KEY_AD_INTERLEVEL_CODE]; ?></textarea>
        <a onclick="ctl_arcade_save_ad_interlevel()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>


        <h3>Leaderboard Style</h3>
        <ul class="ctl-arcade-admin-rank-colors">
            <li><input type="radio" name="rank-style" value="green" <?php
                    echo ( $szRankColor == "green" ? 'checked="checked"' : "" );
                ?>/>green<div class="ctl-arcade-admin-rank-preview-green">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="red" <?php
                    echo ( $szRankColor == "red" ? 'checked="checked"' : "" ); ?>/>red<div
                    class="ctl-arcade-admin-rank-preview-red">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="orange" <?php
                    echo ( $szRankColor == "orange" ? 'checked="checked"' : "" ); ?>/>orange<div class="ctl-arcade-admin-rank-preview-orange">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="pink" <?php
                    echo ( $szRankColor == "pink" ? 'checked="checked"' : "" ); ?>/>pink<div class="ctl-arcade-admin-rank-preview-pink">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="violet" <?php
                    echo ( $szRankColor == "violet" ? 'checked="checked"' : "" ); ?>/>violet<div class="ctl-arcade-admin-rank-preview-violet">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="blue" <?php
                    echo ( $szRankColor == "blue" ? 'checked="checked"' : "" ); ?>/>blue<div class="ctl-arcade-admin-rank-preview-blue">
                    <span></span><span></span></div>
            </li>
            <li><input type="radio" name="rank-style" value="gray" <?php
                    echo ( $szRankColor == "gray" ? 'checked="checked"' : "" ); ?>/>gray<div class="ctl-arcade-admin-rank-preview-gray">
                    <span></span><span></span></div>
            </li>
        </ul>
        <a onclick="ctl_arcade_save_rank_style()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>

        <h3>Extra Css</h3>
        <p>Override our styles here:</p>
        <textarea rows="10" cols="50" id="ctl-arcade-id-extra-css-value"><?php echo $extraCss; ?></textarea>
        <a onclick="ctl_arcade_save_extra_css()" class="ctl-arcade-btn ctl-arcade-btn-mini">save</a>


        <div class="ctl-arcade-game-settings-btn-wrapper">
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_manage_games" class="ctl-arcade-btn">games list</a>
            <a href="<?php echo admin_url(); ?>admin.php?page=ctl_arcade_page_company"
               class="ctl-arcade-btn">about us</a>
        </div>

        <script>

            function isNumberKey(evt) {
                var charCode = (evt.which) ? evt.which : event.keyCode;
                if (charCode != 46 && charCode > 31
                    && (charCode < 48 || charCode > 57))
                    return false;

                return true;
            }

            function ctl_arcade_clear_scores(){
                if (confirm("Are you sure to empty all scores from db?\nThis action isn't reversible!")) {
                    window.top.location = "<?php echo admin_url(); ?>"
                    + "admin.php?page=ctl_arcade_main_menu&action=empty_scores";
                }
            }
            function ctl_arcade_clear_ratings(){
                if (confirm("Are you sure to empty all ratings from db?\nThis action isn't reversible!")) {
                    window.top.location = "<?php echo admin_url(); ?>"
                    + "admin.php?page=ctl_arcade_main_menu&action=empty_ratings";
                }
            }
			function ctl_arcade_save_twitter_share(){
				var bShare = jQuery("#ctl-arcade-id-tw-share-value").is(':checked') ? 1 : 0;
				
                window.top.location = "<?php echo admin_url(); ?>" +
                    "admin.php?page=ctl_arcade_main_menu&action=twitter_settings&twitter_share=" +bShare;
            }
            function ctl_arcade_save_fb_app_id(){
                window.top.location = "<?php echo admin_url(); ?>" +
                    "admin.php?page=ctl_arcade_main_menu&action=fb_app_settings&fb_app_id=" +
                    jQuery("#ctl-arcade-id-fb-app-id-value").val();
            }
            function ctl_arcade_save_min_time_between_ads(){
                window.top.location = "<?php echo admin_url(); ?>" +
                "admin.php?page=ctl_arcade_main_menu&action=min_time_between_ads&time=" +
                jQuery("#ctl-arcade-id-min-time-between-ads").val();
            }
            function ctl_arcade_save_rank_style(){
                window.top.location = "<?php echo admin_url(); ?>"
                + "admin.php?page=ctl_arcade_main_menu&action=rank_style&color=" +
                jQuery("input[name=rank-style]:checked").val();
            }
            function ctl_arcade_save_extra_css(){
                window.top.location = "<?php echo admin_url(); ?>"
                + "admin.php?page=ctl_arcade_main_menu&action=extra_css&css=" +
                Base64.encodeURI(jQuery("#ctl-arcade-id-extra-css-value").val());
            }
            function ctl_arcade_save_ad_preloader(){
                window.top.location = "<?php echo admin_url(); ?>"
                + "admin.php?page=ctl_arcade_main_menu&action=ad_preloader&code=" +
                Base64.encodeURI(jQuery("#ctl-arcade-id-ad-preloader-code").val()) +
                "&mintime=" + jQuery("#ctl-arcade-id-ad-preloader-min-time").val();
            }
            function ctl_arcade_save_ad_interlevel(){
                window.top.location = "<?php echo admin_url(); ?>"
                + "admin.php?page=ctl_arcade_main_menu&action=ad_interlevel&code=" +
                Base64.encodeURI( jQuery("#ctl-arcade-id-ad-interlevel-code").val()) +
                "&mintime=" + jQuery("#ctl-arcade-id-ad-interlevel-min-time").val();
            }
        </script>

    <?php

    }