<?php

   include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

    function ctl_arcade_generate_random_string($length = 10) {
        $characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }

    function ctl_arcade_print_shortcode( $atts ) {
		$cur_url =(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
        ob_start();
     

        $iMinTimeBetweenAds = ctl_arcade_get_min_time_between_ads();

        switch($atts["mode"]){
            case "iframe":{

                $fDebug = true;

                if (!defined('CTL_ARCADE_SHORTCODE_MODE_IFRAME')) {
                    define('CTL_ARCADE_SHORTCODE_MODE_IFRAME',true);
                } else {
                    break;
                }

                if( is_plugin_inactive( $atts["game"] . "/". $atts["game"] .".php")){
                    ?>
                    <div>
                        <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Disabled or not Installed!</p>
                    </div>
                <?php
                }else{
                    global $wpdb;

                    $oGame = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES .
                        " WHERE game_plugin_dir = '". $atts["game"] ."'" );
                    $oGame = $oGame[0];

                    if(!$oGame){
                        ?>
                        <div>
                            <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Not Installed!</p>
                        </div>
                        <?php
                        return;
                    }

					$szTestPath = plugin_dir_path(__FILE__)."../../". $atts["game"]."/game/";
					if ( file_exists($szTestPath.'index.html') ){
						$iframeUrl = plugins_url() . "/". $atts["game"] . "/game/index.html?ctl-arcade=true";
					}else if ( file_exists($szTestPath.'index.php')  ){
						$iframeUrl = plugins_url() . "/". $atts["game"] . "/game/index.php?ctl-arcade=true";
					}else{
						$iframeUrl = plugins_url() . "/". $atts["game"] . "/game/?ctl-arcade=true";
					}
                    ?>

                    <script>
						var _oCtlArcadeIframeGlobalData = {};
						_oCtlArcadeIframeGlobalData["socials"] = [];
						_oCtlArcadeIframeGlobalData["prevScore"] = 0;
						_oCtlArcadeIframeGlobalData["score"]     = 0;
						_oCtlArcadeIframeGlobalData["shareObj"]  = null;
						_oCtlArcadeIframeGlobalData['game_name'] = '<?php echo $oGame->game_name; ?>';
						_oCtlArcadeIframeGlobalData['url'] = '<?php echo $cur_url ?>';
						
						 <?php
							
							if( ctl_arcade_get_twitter_share() != "0" ) {
								?>
								_oCtlArcadeIframeGlobalData["socials"].push({ "txt" : "twitter", "cb" : "", "class": "twitter-share-button"});
								_oCtlArcadeIframeGlobalData["prevScore"] = 0;
								_oCtlArcadeIframeGlobalData["score"]     = 0;
								_oCtlArcadeIframeGlobalData["shareObj"]  = null;
						<?php
							}
					
                            if( ctl_arcade_get_fb_app_id() != "" ) {
                                ?>
                                _oCtlArcadeIframeGlobalData["socials"].push(
                                    {"txt" : "facebook", "cb" : "__ctlArcadeShareFacebook", "class": ""});
                                <?php
                            }

                            if ( is_user_logged_in() ) {
                              $current_user = wp_get_current_user();
                              echo '_oCtlArcadeIframeGlobalData["userName"] = "' . $current_user->display_name . '";';
                              echo '_oCtlArcadeIframeGlobalData["idUser"] = ' . $current_user->ID . ";";
                            }
                        ?>

                        function __ctlArcadeSaveScore( oData ){

                            <?php
                                if($fDebug){
                                  ?>
                                        console.log("__ctlArcadeSaveScore: " + oData.score );
                                <?php
                                }
                            ?>


                            if( oData.score === 0){
                                return;
                            }

                            _oCtlArcadeIframeGlobalData["prevScore"] = _oCtlArcadeIframeGlobalData["score"];
                            _oCtlArcadeIframeGlobalData["score"] = oData.score;

                            if( _oCtlArcadeIframeGlobalData["idUser"]){
                                ctlArcadeSaveScore(
                                    "<?php echo plugins_url(); ?>/ctl-arcade/front/ajax.php",
                                    oData.score,
                                    _oCtlArcadeIframeGlobalData["idUser"],
                                    "<?php echo $atts["game"]; ?>",
                                    _oCtlArcadeIframeGlobalData["socials"]
                                );
                            }
                        }

                        function __ctlArcadeShareEvent(oData){
								if(_oCtlArcadeIframeGlobalData["socials"].length < 1){
									return;
								}
							console.trace();
                                _oCtlArcadeIframeGlobalData["shareObj"] = oData;
                                ctlArcadeShareEvent(
                                    oData.title,
                                    oData.msg,
                                    _oCtlArcadeIframeGlobalData["socials"],
									_oCtlArcadeIframeGlobalData
								);

                            <?php
                            if($fDebug){
                            ?>
                                console.log("__ctlArcadeShareEvent");
                            <?php
                            }
                            ?>
                        }

                        function __ctlArcadeStartSession() {
                            <?php
                            if($fDebug){
                             ?>
                            console.log("__ctlArcadeStartSession");
                            <?php
                            }
                        ?>
                        }

                        function __ctlArcadeEndSession() {
                            <?php
                            if($fDebug){
                                ?>
                            console.log("__ctlArcadeEndSession");
                            <?php
                            }
                            ?>
                        }

                        function __ctlArcadeShowInterlevelAD(){
                            <?php
                            if( ctl_arcade_is_ad_interlevel() ){
                            ?>
                                ctlArcadeShowAdsInterlevel(
                                    <?php echo ctl_arcade_get_ad_interlevel_min_time(); ?>,
                                    <?php echo $iMinTimeBetweenAds; ?> );
                            <?php
                            }
                            if($fDebug){
                            ?>
                                console.log("__ctlArcadeShowInterlevelAD");
                            <?php
                            }
                        ?>
                        }

                        function __ctlArcadeStartLevel(){
                            <?php
                            if($fDebug){
                                ?>
                            console.log("__ctlArcadeStartLevel");
                            <?php
                            }
                            ?>
                        }

                        function __ctlArcadeRestartLevel(){
                            <?php
                            if($fDebug){
                                ?>
                            console.log("__ctlArcadeRestartLevel");
                            <?php
                            }
                            ?>
                        }

                        function __ctlArcadeEndLevel(){
                            <?php
                            if($fDebug){
                                ?>
                            console.log("__ctlArcadeEndLevel");
                            <?php
                            }
                            ?>
                        }

                        function __ctlArcadeShareFacebook(){
                            ctlArcadeShareFacebook(
                                "<?php echo $cur_url; ?>",
                                "<?php echo $oGame->game_name; ?>",
                                "<?php echo get_bloginfo("name"); ?>",
                                _oCtlArcadeIframeGlobalData["shareObj"].msg_share,
                                "<?php echo get_site_url() . "/wp-content/plugins/" .
                                $oGame->game_plugin_dir . "/images/" ?>" + _oCtlArcadeIframeGlobalData["shareObj"]
                                    .img );
                        }
                    </script>

                    <?php		
                        $bAdsPreloader = ctl_arcade_is_ad_preloader();

                        if( $bAdsPreloader ){
                            ?>
                            <script>
                                jQuery(window).ready(function(){
                                    ctlArcadeShowAdsPreloader(
                                        <?php echo ctl_arcade_get_ad_preloader_min_time(); ?>,
                                        <?php echo $iMinTimeBetweenAds; ?>);
                                });
                            </script>
                            <?php
                        }

                    ?>

                    <div class="ctl-arcade-game-iframe-wrapper">
                        <iframe allowfullscreen="true" class='ctl-arcade-game-iframe'
                            <?php
                                if(isset($atts["max-height"])) {
                                    echo 'data-max-height="' . $atts["max-height"] . '"';
                                }
                             ?>
                            data-aspect-ratio="<?php echo $oGame->game_aspect_ratio; ?>"
                            data-src="<?php echo $iframeUrl;?>"
                            src="<?php
                                if( !$bAdsPreloader ){
                                    echo $iframeUrl;
                                }
                            ?>"
                            width="100%"
                            height="500px"
                            scrolling="no"></iframe>
                    </div>

                <?php
                }
            }break;
            case "leaderboard":{
                if (!defined('CTL_ARCADE_SHORTCODE_MODE_RANK')) {
                    define('CTL_ARCADE_SHORTCODE_MODE_RANK',true);
                } else {
                    break;
                }

                if( is_plugin_inactive( $atts["game"] . "/". $atts["game"] .".php")){
                    ?>
                    <div>
                        <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Disabled or not Installed!</p>
                    </div>
                <?php
                }else{
                    _ctl_arcade_print_rank($atts);
                }
            }break;
            case "rating":{
                if (!defined('CTL_ARCADE_SHORTCODE_MODE_RATING')) {
                    define('CTL_ARCADE_SHORTCODE_MODE_RATING',true);
                } else {
                    break;
                }

                if( is_plugin_inactive( $atts["game"] . "/". $atts["game"] .".php")){
                    ?>
                    <div>
                        <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Disabled or not Installed!</p>
                    </div>
                <?php
                }else{
                    _ctl_arcade_print_rating($atts);
                }
            }break;
        }

        return ob_get_clean();
    }

    function _ctl_arcade_print_rating($atts){
 
        global $wpdb;

        $oGame = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES .
                                    " WHERE game_plugin_dir = '". $atts["game"] ."'" );
        $oGame = $oGame[0];

        if(!$oGame){
            ?>
            <div>
                <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Not Installed!</p>
            </div>
        <?php
            return;
        }

        $current_user = wp_get_current_user();
        $user_id = ( $current_user ? $current_user->ID : 0 );

        if( intval($oGame->game_rating_num_votes) == 1){
            $szStringVotes = "vote";
        }else{
            $szStringVotes = "votes";
        }

        ?>

        <div class="ctl-arcade-rating-container ctl-noselect"
             data-user-id="<?php echo $user_id;?>"
             data-game="<?php echo $atts["game"]; ?>"
             data-num-votes="<?php echo $oGame->game_rating_num_votes; ?>"
             data-value-votes="<?php echo $oGame->game_rating_value_votes; ?>">
            <div class="ctl-arcade-stars">
                <span data-rate="1"><i class="ctl-arcade-icon-star-empty"></i></span>
                <span data-rate="2"><i class="ctl-arcade-icon-star-empty"></i></span>
                <span data-rate="3"><i class="ctl-arcade-icon-star-empty"></i></span>
                <span data-rate="4"><i class="ctl-arcade-icon-star-empty"></i></span>
                <span data-rate="5"><i class="ctl-arcade-icon-star-empty"></i></span>
            </div>
            <div class="ctl-arcade-num-votes">
                <span><?php echo $oGame->game_rating_num_votes . " " . $szStringVotes; ?></span>
            </div>
        </div>

        <?php
    }

    function _ctl_arcade_print_rank($atts){
        global $wpdb;

        $oGame = $wpdb->get_results( "SELECT * FROM " . CTL_ARCADE_DB_TABLE_GAMES . " WHERE game_plugin_dir
                = '". $atts["game"] ."'" );
        $oGame = $oGame[0];

        if(!$oGame){
            ?>
            <div>
                <p class="ctl-arcade-admin-message-red">Game <?php echo $atts["game"]; ?> Not Installed!</p>
            </div>
            <?php
            return;
        }

        if( $oGame->game_rank == 0 ){
            ?>
            <div>
                <p class="ctl-arcade-admin-message-red">No leaderboard available for game <?php echo $atts["game"]; ?>!</p>
            </div>
            <?php
            return;
        }

        $szRankColor = ctl_arcade_get_rank_style_color();

        ?>
        <div class="ctl-arcade-rank-container">

        </div>
        <script>
            var _szPeriod = '<?php echo $atts["period"]; ?>';

            function ctlArcadeRefreshRank( szPeriod ){

                if(szPeriod && szPeriod !== "refresh"){
                    _szPeriod = szPeriod;
                }

                jQuery.ajax({
                    url: "<?php echo plugins_url(); ?>/ctl-arcade/front/ajax.php",
                    type: "post",
                    data: {
                        "action" : "get-rank",
                        "limit"  : "<?php echo $atts["limit"]; ?>",
                        "game"   : "<?php echo $atts["game"]; ?>",
                        "order"  : "<?php echo $atts["order"]; ?>",
                        "period"  : _szPeriod
                    }
                }).done(function (data) {
                    data = ctlArcadeGetUrlVars(data);

                    if (data.status === "true"){
                        data.scores = jQuery.parseJSON(data.scores);

                        var szHtml = "";
                        szHtml += '<div class="ctl-arcade-rank-table ctl-arcade-rank-table-<?php echo $szRankColor;
                        ?>">';

                        switch(_szPeriod){
                            case "weekly":{
                                szHtml += '<p><?php echo $oGame->game_name; ?> - weekly leaderboard - top <?php echo
                                $atts["limit"];
                                ?></p>';
                            }break;
                            case "monthly":{
                                szHtml += '<p><?php echo $oGame->game_name; ?> - monthly leaderboard - top <?php echo $atts["limit"]; ?></p>';
                            }break;
                            case "all-time":{
                                szHtml += '<p><?php echo $oGame->game_name; ?> - all time leaderboard - top <?php echo $atts["limit"]; ?></p>';
                            }break;
                        }

                        szHtml += '<div class="ctl-arcade-rank-header ctl-arcade-rank-header-<?php echo $szRankColor;
                        ?>">';
                        szHtml += '<div class="ctl-arcade-rank-col ctl-col-3 ctl-arcade-text-right">#</div>';
                        szHtml += '<div class="ctl-arcade-rank-col ctl-col-6 ctl-arcade-text-right">user</div>';
                        szHtml += '<div class="ctl-arcade-rank-col ctl-col-3 ctl-arcade-text-right">score</div>';
                        szHtml += '</div>';
                        szHtml += '<div class="ctl-arcade-rank-body">';

                        if( data.scores.length === 0 ){
                            szHtml += '<p class="ctl-arcade-rank-no-scores">There are no scores!</p>';
                        }else {
                            for (var i = 0; i < data.scores.length; i++) {
                                var oScore = data.scores[i];
                                szHtml += '<div class="ctl-arcade-rank-row">';
                                szHtml += '<div class="ctl-arcade-rank-col ctl-col-3 ctl-arcade-text-right">' + (i+1) + '.</div>';
                                szHtml += '<div class="ctl-arcade-rank-col ctl-col-6 ctl-arcade-text-right">' + oScore.display_name + '</div>';
                                szHtml += '<div class="ctl-arcade-rank-col ctl-col-3 ctl-arcade-text-right">' + oScore.user_score + '</div>';
                                szHtml += '</div>';
                            }
                        }

                        szHtml += '</div>';
                        szHtml += '</div>';
                        szHtml += '<div class="ctl-arcade-rank-filters">';
                            szHtml += '<ul>';
                                szHtml += '<li class="ctl-arcade-btn ctl-arcade-btn-mini ctl-arcade-btn-<?php echo $szRankColor; ?>" title="refresh" data-period="refresh">';
                                    szHtml += '<i class="ctl-arcade-icon-arrows-cw"></i>';
                                szHtml += '</li>';
                                szHtml += '<li class="ctl-arcade-btn ctl-arcade-btn-mini ctl-arcade-btn-<?php echo $szRankColor; ?>" data-period="weekly">weekly</li>';
                                szHtml += '<li class="ctl-arcade-btn ctl-arcade-btn-mini ctl-arcade-btn-<?php echo $szRankColor; ?>" data-period="monthly">monthly</li>';
                                szHtml += '<li class="ctl-arcade-btn ctl-arcade-btn-mini ctl-arcade-btn-<?php echo $szRankColor; ?>" data-period="all-time">all time</li>';
                            szHtml += '</ul>';
                        szHtml += '</div>';

                        jQuery(".ctl-arcade-rank-container").html(szHtml);
                    }else{

                    }
                }).fail(function (jqXHR, textStatus) {

                });

            }

            ctlArcadeRefreshRank();
            // setInterval( __getRank, 3000);

            jQuery(window).ready(function(){
                jQuery(document).on("click",".ctl-arcade-rank-filters li", function() {
                    ctlArcadeRefreshRank(jQuery(this).attr("data-period"));
                });
            });
        </script>

    <?php 
    }
