/**
 * Created by codethislab on 13/10/15.
 */
(function() {
    tinymce.create('tinymce.plugins.ctl_arcade_shortcode_buttons', {
        init : function(ed, url) {

            ed.addButton('ctl_arcade_shortcode_add_game_iframe', {
                title : 'Add Game Widget',
                classes : 'ctl-arcade-icon-gamepad',
                cmd : 'ctl_arcade_shortcode_add_game_iframe'
            });

            ed.addButton('ctl_arcade_shortcode_add_game_rank', {
                title : 'Add Game Leaderboard',
                classes : 'ctl-arcade-icon-award',
                cmd : 'ctl_arcade_shortcode_add_game_rank'
            });
            ed.addButton('ctl_arcade_shortcode_add_game_rating', {
                title : 'Add Game Rating',
                classes : 'ctl-arcade-icon-star',
                cmd : 'ctl_arcade_shortcode_add_game_rating'
            });

            ed.addCommand('ctl_arcade_shortcode_add_game_iframe', function() {
                ed.windowManager.open( {
                    url : url + '/../pages/shortcode-composer-iframe.php?mode=game',
                    height: 400,
                    title: 'Insert a Game Widget'
                });
            });

            ed.addCommand('ctl_arcade_shortcode_add_game_rank', function() {
                ed.windowManager.open( {
                    url : url + '/../pages/shortcode-composer-iframe.php?mode=leaderboard',
                    height: 450,
                    title: 'Insert a Game Leaderboard'
                });
            });

            ed.addCommand('ctl_arcade_shortcode_add_game_rating', function() {
                ed.windowManager.open( {
                    url : url + '/../pages/shortcode-composer-iframe.php?mode=rating',
                    height: 450,
                    title: 'Insert a Game Rating'
                });
            });
        }
    });
    // Register plugin
    tinymce.PluginManager.add( 'ctl_arcade_shortcode_buttons', tinymce.plugins.ctl_arcade_shortcode_buttons );
})();